/*
Copyright The KubeEdge Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	time "time"

	sednav1alpha1 "github.com/kubeedge/sedna/pkg/apis/sedna/v1alpha1"
	versioned "github.com/kubeedge/sedna/pkg/client/clientset/versioned"
	internalinterfaces "github.com/kubeedge/sedna/pkg/client/informers/externalversions/internalinterfaces"
	v1alpha1 "github.com/kubeedge/sedna/pkg/client/listers/sedna/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// ObjectTrackingServiceInformer provides access to a shared informer and lister for
// ObjectTrackingServices.
type ObjectTrackingServiceInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.ObjectTrackingServiceLister
}

type objectTrackingServiceInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewObjectTrackingServiceInformer constructs a new informer for ObjectTrackingService type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewObjectTrackingServiceInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredObjectTrackingServiceInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredObjectTrackingServiceInformer constructs a new informer for ObjectTrackingService type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredObjectTrackingServiceInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.SednaV1alpha1().ObjectTrackingServices(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.SednaV1alpha1().ObjectTrackingServices(namespace).Watch(context.TODO(), options)
			},
		},
		&sednav1alpha1.ObjectTrackingService{},
		resyncPeriod,
		indexers,
	)
}

func (f *objectTrackingServiceInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredObjectTrackingServiceInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *objectTrackingServiceInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&sednav1alpha1.ObjectTrackingService{}, f.defaultInformer)
}

func (f *objectTrackingServiceInformer) Lister() v1alpha1.ObjectTrackingServiceLister {
	return v1alpha1.NewObjectTrackingServiceLister(f.Informer().GetIndexer())
}
